> For the complete documentation index, see [llms.txt](https://docs.notional.finance/v3-technical-docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.notional.finance/v3-technical-docs/currency-ids-and-precision/notional-internal-precision.md).

# Notional Internal Precision

## Balances

Notional's internal balance precision is 8 decimals. For example, here is a non-exhaustive list of balance related variables with 1e8 precision:

* User Prime Cash and Prime Debt balances
* User nToken balances
* User fCash balances
* nToken liquidity token balances
* User Vault Share Balances
* User Free Collateral balances
* fCash markets total Prime Cash and total fCash balances
* Prime Cash totalUnderlyingSupply balances
* maxUnderlyingSupply parameters&#x20;
* Leveraged Vaults minAccountBorrowSize parameters

## Rates

Notional's internal rate precision is 9 decimals. For example, here is a non-exhaustive list of rates related variables with 1e9 precision:

* `fCashOracleRates`
* `fCashLastImpliedRates`
* `oracleSupplyRate`
* Leveraged Vaults `minCollateralRatio`, `maxRequiredAccountCollateralRatio`, `maxDeleverageCollateralRatio`, `liquidationRate`, and `feeRate` parameters

## Scalars

Prime Cash scalars are 1e18 precision. For example, the precision of the following variables is 1e18:

* `debtScalar`
* `supplyScalar`
* `underlyingScalar`

## Prime factors

The Prime Cash `debtFactor`and `supplyFactor` precision is 1e36.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.notional.finance/v3-technical-docs/currency-ids-and-precision/notional-internal-precision.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
